<?php
/**
 * @file
 * Providing some drush commands.
 */

/**
 * Implements hook_drush_command().
 */
function ldapcontrol_drush_command() {
  $items = array();

  $items['ldapctrl-imp-one'] = array(
    'callback' => '_ldapcontrol_drushcallback_one',
    'description' => "import one drupal user in ldap, arg=UID",
  );
  $items['ldapctrl-imp-group'] = array(
    'callback' => '_ldapcontrol_drushcallback_group',
    'description' => "import a group of drupal users in ldap, args: from UID to UID",
  );
  $items['ldapctrl-imp-all'] = array(
    'callback' => '_ldapcontrol_drushcallback_all',
    'description' => "import all drupal users in ldap, no arg",
  );
  return $items;
}

/**
 * Implements hook_drush_help().
 */
function ldapcontrol_drush_help($section) {
  switch ($section) {
    case 'drush:ldpapcontrol-import-one':
      return dt("import one drupal user in ldap and/or update LDAP auth information. Argument: one single user ID (UID)");

    case 'drush:ldpapcontrol-import-group':
      return dt("import a group of drupal users in ldap and/or update LDAP auth information. Arguments: from UID to UID");

    case 'drush:ldpapcontrol-import-all':
      return dt("import all drupal users in ldap and/or update LDAP auth information. No argument needed");

  }
}

/**
 * Drush command callback.
 */
function _ldapcontrol_drushcallback_one() {
  $args = func_get_args();
  $my_return = t('no argument');
  if ($args[0] != NULL) {
    $my_return = _ldapcontrol_imp_one_drush($args[0]);
  }
  drush_print($my_return);
}

/**
 * Drush command callback.
 */
function _ldapcontrol_drushcallback_group() {
  $args = func_get_args();
  $return = t('no argument');
  if (($args[0] != NULL) && ($args[1] != NULL)) {
    $return = _ldapcontrol_imp_group_drush($args[0], $args[1]);
  }
  drush_print($return);
}

/**
 * Drush command callback.
 */
function _ldapcontrol_drushcallback_all() {
  $return = _ldapcontrol_imp_all_drush();
  drush_print($return);
}
